<template>
    <div :class="{'white-block': !history}" ref="el">

        <payment>
            <div slot="close" class="box-modal_close arcticmodal-close" @click="$parent.pay = false;" v-if="!history"></div>
            <div slot="installment" class="details" v-if="!history">
                <div class="question-block q-blue q-big">
                    <div class="question padding" @click="displayDetails = !displayDetails">
                        <div class="row">
                            <div class="columns five">Необходимо внести <strong>{{currentPay.amount|currency}} &#8381;</strong></div>
                            <div class="columns seven">До <strong>{{$dayjs(currentPay.date).format('DD.MM.YYYY')}}</strong></div>
                        </div>
                        <img src="/static/img/pos/arrow.png" alt="" class="faq-arrow" :class="{expand: displayDetails}"/>
                    </div>
                </div>
                <transition name="fade" class="answer">
                    <payment-details :item="currentPay" v-if="displayDetails"></payment-details>
                </transition>
            </div>
        </payment>

        <!--<div ref="payForm" class="payform">-->
            <!--<div class="close" @click="$events.$emit('installment.block.pay', false);"></div>-->
            <!--<component :is="paymentComponent" v-model="sum"></component>-->
        <!--</div>-->

        <!--<hr>-->
        <!--<div class="question-block q-white">-->
            <!--<div class="question padding" @click="displayAllMethods = !displayAllMethods"-->
                 <!--:class="{expand_block: true, expanded_block: displayAllMethods}">-->
                <!--Другие способы пополнения-->
            <!--</div>-->
            <!--<transition name="fade">-->
                <!--<payment-list v-if="displayAllMethods"/>-->
            <!--</transition>-->
        <!--</div>-->

        <!--<div class="question-block q-blue q-big">-->
            <!--<div class="question padding" @click="displayDetails = !displayDetails">-->
                <!--<div class="row">-->
                    <!--<div class="columns five">Необходимо внести <strong>21 677 &#8381;</strong></div>-->
                    <!--<div class="columns seven">До <strong>31 Августа</strong></div>-->
                <!--</div>-->
                <!--<img src="img/pos/arrow.png" alt="" class="faq-arrow" />-->
            <!--</div>-->
        <!--</div>-->
        <!--<transition name="fade" class="answer">-->
            <!--<payment-details :item="currentPay" v-if="displayDetails"></payment-details>-->
        <!--</transition>-->

    </div>
</template>

<script>
  import paymentList from './systems'
  import paymentDetails from '../Schedule/PaymentDetails'
  import paymentBlock from './index.vue';
  import payment from '@/components/Pay/Payment.vue';
  export default {
    name: 'paymentBlock',
    components: {
      paymentList,
      paymentDetails,
      paymentBlock,
      payment
    },
    provide: {
      ActiveLoan: this
    },
    props: {
      history: {
        required: false,
        default: false,
      }
    },

    data () {
      return {
        sum: 0,
        displayAllMethods: false,
        displayDetails: false,
        displayDetailsHistory: {},
        // history: [],
      }
    },

    computed: {

      currentPay () {
        const current = this.$dayjs().format('YYYY-MM')
        return this.$installment.schedule.find((s) => {
          return s.date.startsWith(current)
        }) || this.$installment.schedule[0];
      },

      paymentAmount: {
        get () {
          return this.sum;
        },

        set (v) {
          this.sum = v;
        }
      },

      paymentComponent () {
        return require('./systems/CardPay/index').default;
      },
    },

    watch: {
      watch: {
        currentPay: {
          deep: true,
          /**
           * @param {INSTALLMENT_SCHEDULE} pay
           */
          handler (pay) {
            this.sum = 0;
            pay.sales.forEach(( s) => {
              if(s.selected) {
                this.sum += s.amount;
              }
            })
          }
        }
      },
    },

    created () {

      this.$events.$on('payform.focus', ({sum}) => {
        this.sum = sum;
        this.$helpers.scroll(this.$refs.$el);
      });

      this.$store.commit('SET_PAYMENT', {
        type: "installment_payment",
        amount: this.getPaymentAmount(),
      });
    },

    mounted () {
      if (!["installment-schedule"].includes(this.$route.name)) {
        this.$helpers.scroll(this.$el);
      }
    },

    beforeDestroy () {
      this.$events.$off('payform.focus')
    },

    methods: {
      getPaymentAmount () {
        let amount = 0;
        if (this.$installment.currentPaymentBySchedule ) {
          this.$installment.currentPaymentBySchedule.sales.forEach((sale) => {
            if (sale.selected) {
              amount += sale.amount;
            }
          })
        }
        return amount;
      }
    }
  }
</script>

<style scoped lang="scss">
    div.payform {
        position: relative;

        &  div.close {
            width: 24px;
            height: 24px;
            background: url(/lk/static/img/icons/close.png) 7px 7px no-repeat;
            position: absolute;
            top: 10px;
            right: 10px;

            &:hover {
                background-position: 7px -84px;
                cursor: pointer;
            }
        }
    }

</style>